Unit afg6z_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AA02Z_p;

procedure afg6z(NM :Integer; N :Integer; LOW :Integer; IGH :Integer;
                var AR :Array of Extended; var AI :Array of Extended;
                var INT :Array of Integer);

implementation

procedure afg6z(NM :Integer; N :Integer; LOW :Integer; IGH :Integer;
                var AR :Array of Extended; var AI :Array of Extended;
                var INT :Array of Integer);
var
I,J,KP1,LA,M,MM1,MP1 :Integer;
X,XI,XR,YI,YR,ZI,ZR :Extended;
const
SYS056 :Real = 5.56268464627e-308;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120;
begin
LA  := IGH - 1;
KP1  := LOW + 1;
if ( LA  <  KP1 ) 
 then goto _120;
for M:=KP1 to LA do
 begin
  MM1  := M - 1;
  XR  := 0.0e0;
  XI  := 0.0e0;
  I  := M;
  for J:=M to IGH do
   begin
    if ( Abs(AR[(J-1)+(MM1-1)*NM]) + Abs(AI[(J-1)+(MM1-1)*NM]) <=  Abs(XR) +
         Abs(XI) ) 
     then goto _10;
    XR  := AR[(J-1)+(MM1-1)*NM];
    XI  := AI[(J-1)+(MM1-1)*NM];
    I  := J;
_10:
   end;
  INT[M-1] := I;
  if ( I  =  M ) 
   then goto _40;
  for J:=MM1 to N do
   begin
    YR  := AR[(I-1)+(J-1)*NM];
    AR[(I-1)+(J-1)*NM] := AR[(M-1)+(J-1)*NM];
    AR[(M-1)+(J-1)*NM] := YR;
    YI  := AI[(I-1)+(J-1)*NM];
    AI[(I-1)+(J-1)*NM] := AI[(M-1)+(J-1)*NM];
    AI[(M-1)+(J-1)*NM] := YI;
_20:
   end;
  for J:=1 to IGH do
   begin
    YR  := AR[(J-1)+(I-1)*NM];
    AR[(J-1)+(I-1)*NM] := AR[(J-1)+(M-1)*NM];
    AR[(J-1)+(M-1)*NM] := YR;
    YI  := AI[(J-1)+(I-1)*NM];
    AI[(J-1)+(I-1)*NM] := AI[(J-1)+(M-1)*NM];
    AI[(J-1)+(M-1)*NM] := YI;
_30:
   end;
_40:
  X  := EMax1(Abs(XR),Abs(XI));
  if ( X  =  0.0e0 ) 
   then goto _110;
  if ( X - SYS056 ) < 0
   then goto _50
   else if ( X - SYS056 ) > 0
         then goto _60
         else goto _50;
_50:
  AR[(M-1)+(M-2)*NM] := 0.0e0;
  AI[(M-1)+(M-2)*NM] := 0.0e0;
  ZR  := 0.0e0;
  ZI  := 0.0e0;
  goto _70;
_60:
  YR  := 1.0e0;
  YI  := 0.0e0;
  AA02Z(YR,YI,XR,XI,ZR,ZI);
_70:
  MP1  := M + 1;
  for I:=MP1 to IGH do
   begin
    XR  := AR[(I-1)+(MM1-1)*NM];
    XI  := AI[(I-1)+(MM1-1)*NM];
    YR  := XR*ZR - XI*ZI;
    YI  := XI*ZR + XR*ZI;
    AR[(I-1)+(MM1-1)*NM] := YR;
    AI[(I-1)+(MM1-1)*NM] := YI;
    if ( YR  =  0.0e0  ) and (  YI  =  0.0e0 ) 
     then goto _100;
    for J:=M to N do
     begin
      AR[(I-1)+(J-1)*NM] := AR[(I-1)+(J-1)*NM] - YR*AR[(M-1)+(J-1)*NM] + YI*AI[(M-1)+(J-1)*NM];
      AI[(I-1)+(J-1)*NM] := AI[(I-1)+(J-1)*NM] - YR*AI[(M-1)+(J-1)*NM] - YI*AR[(M-1)+(J-1)*NM];
_80:
     end;
    for J:=1 to IGH do
     begin
      AR[(J-1)+(M-1)*NM] := AR[(J-1)+(M-1)*NM] + YR*AR[(J-1)+(I-1)*NM] - YI*AI[(J-1)+(I-1)*NM];
      AI[(J-1)+(M-1)*NM] := AI[(J-1)+(M-1)*NM] + YR*AI[(J-1)+(I-1)*NM] + YI*AR[(J-1)+(I-1)*NM];
_90:
     end;
_100:
   end;
_110:
 end;
_120:
end;

end.
